# TODO
# - make --with-libradius compile
#

# Conditional build:
%bcond_without	kerberos5	# build with GSSAPI support
%bcond_without	ldap		# build with LDAP support
%bcond_with	radius		# build with radius support
%bcond_with	hip		# build with Host Identity Protocol support
#
Summary:	User-space IPsec tools for the Linux IPsec implementation
Summary(pl.UTF-8):	Narzędzia przestrzeni użytkownika dla linuksowej implementacji IPsec
Name:		ipsec-tools
Version:	0.8.2
Release:	5
License:	BSD
Group:		Networking/Admin
Source0:	http://downloads.sourceforge.net/ipsec-tools/%{name}-%{version}.tar.bz2
# Source0-md5:	d53ec14a0a3ece64e09e5e34b3350b41
Source1:	%{name}-racoon.init
Source2:	%{name}-racoon.sysconfig
Source3:	%{name}.tmpfiles
URL:		http://ipsec-tools.sourceforge.net/
# http://downloads.sourceforge.net/openhip/ipsec-tools-0.6.6-hip.patch
Patch0:		%{name}-hip.patch
Patch1:		%{name}-gssapi.patch
Patch2:		%{name}-support-glibc-2.20.patch
Patch3:		%{name}-link.patch
Patch4:		no-sysctl.patch
Patch5:		%{name}-openssl-1.1.patch
BuildRequires:	autoconf >= 2.52
BuildRequires:	automake
BuildRequires:	bison
BuildRequires:	flex
%{?with_kerberos5:BuildRequires:	heimdal-devel}
BuildRequires:	libselinux-devel
BuildRequires:	libtool
BuildRequires:	linux-libc-headers >= 7:2.6
%{?with_ldap:BuildRequires:	openldap-devel >= 2.4.6}
BuildRequires:	openssl-devel >= 0.9.8s
BuildRequires:	pam-devel
# http://portal-to-web.de/tacacs/libradius.php ?
%{?with_radius:BuildRequires:	libradius-devel}
BuildRequires:	readline-devel
BuildRequires:	sed >= 4.0
Requires(post,preun):	/sbin/chkconfig
Requires:	libipsec = %{version}-%{release}
Requires:	rc-scripts
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# requires adminsock_path symbol from binary
%define		skip_post_check_so	libracoon.so.*

# needed to use /var/run/racoon as sockdir
%define		_localstatedir		/var/run

%description
IPsec-Tools is a port of the KAME Project's IPsec tools to the Linux
IPsec implementation. IPsec-Tools provides racoon, an IKE daemon;
libipsec, a PFKey implementation; and setkey, a security policy and
security association database configuration utility.

%description -l pl.UTF-8
IPsec-Tools to port narzędzi IPsec z projektu KAME do linuksowej
implementacji IPsec. IPsec-Tools dostarczają: racoona - demona IKE;
libipsec - implementację PFKey; oraz setkey - narzędzie konfiguracyjne
do polityki bezpieczeństwa oraz asocjacyjnej bazy danych
bezpieczeństwa.

%package -n libipsec
Summary:	Shared libipsec and libracoon libraries
Summary(pl.UTF-8):	Biblioteki współdzielone libipsec i libracoon
Group:		Libraries

%description -n libipsec
Shared libipsec and libracoon libraries.

%description -n libipsec -l pl.UTF-8
Biblioteki współdzielone libipsec i libracoon.

%package -n libipsec-devel
Summary:	Header files for libipsec and racoon libraries
Summary(pl.UTF-8):	Pliki nagłówkowe bibliotek libipsec i racoon
Group:		Development/Libraries
Requires:	libipsec = %{version}-%{release}

%description -n libipsec-devel
Header files for libipsec and racoon libraries.

%description -n libipsec-devel -l pl.UTF-8
Pliki nagłówkowe bibliotek libipsec i racoon.

%package -n libipsec-static
Summary:	Static libipsec and libracoon libraries
Summary(pl.UTF-8):	Biblioteki statyczne libipsec i libracoon
Group:		Development/Libraries
Requires:	libipsec-devel = %{version}-%{release}

%description -n libipsec-static
Static libipsec and libracoon libraries.

%description -n libipsec-static -l pl.UTF-8
Biblioteki statyczne libipsec i libracoon.

%prep
%setup -q
%{?with_hip:%patch0 -p1}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

%{__sed} -i 's!@INCLUDE_GLIBC@!!g' src/Makefile.am
%{__sed} -i 's/-Werror//' configure.ac
%{__sed} -i 's/-R\$[^ ]*\/lib//' configure.ac

%build
%{__libtoolize}
%{__aclocal} -I .
%{__autoconf}
%{__autoheader}
%{__automake}

%configure \
	--enable-adminport \
	--enable-dpd \
	--enable-frag \
	%{?with_kerberos5:--enable-gssapi} \
	--enable-hybrid \
	--enable-idea \
	--enable-natt \
	--enable-rc5 \
	--enable-security-context \
	--enable-shared \
	--enable-stats \
	--with-kernel-headers=%{_includedir} \
	--with-libldap%{!?with_ldap:=no} \
	--with-libpam \
	%{?with_radius:--with-libradius} \
	--with-readline

%{__make} -j1

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/etc/{rc.d/init.d,racoon,sysconfig} \
	$RPM_BUILD_ROOT/usr/lib/tmpfiles.d

%{__make} -j1 install \
	DESTDIR=$RPM_BUILD_ROOT

install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/racoon
install %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/racoon
install %{SOURCE3} $RPM_BUILD_ROOT/usr/lib/tmpfiles.d/%{name}.conf
install src/racoon/samples/*.txt src/racoon/samples/*.conf $RPM_BUILD_ROOT%{_sysconfdir}/racoon

%{__rm} $RPM_BUILD_ROOT%{_libdir}/lib*.la

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add racoon
if [ -f /var/lock/subsys/racoon ]; then
	/etc/rc.d/init.d/racoon restart 1>&2
else
	echo "Type \"/etc/rc.d/init.d/racoon start\" to start racoon." 1>&2
fi

%preun
if [ "$1" = "0" ]; then
	if [ -f /var/lock/subsys/racoon ]; then
		/etc/rc.d/init.d/racoon stop >&2
	fi
	/sbin/chkconfig --del racoon
fi

%post	-n libipsec -p /sbin/ldconfig
%postun	-n libipsec -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc NEWS README ChangeLog src/racoon/{doc,samples} src/setkey/sample*
%attr(755,root,root) %{_sbindir}/plainrsa-gen
%attr(755,root,root) %{_sbindir}/racoon
%attr(755,root,root) %{_sbindir}/racoonctl
%attr(755,root,root) %{_sbindir}/setkey
%attr(754,root,root) /etc/rc.d/init.d/racoon
%attr(750,root,root) %dir %{_sysconfdir}/racoon
%config(noreplace) %verify(not md5 mtime size) %attr(600,root,root) %{_sysconfdir}/racoon/*.txt
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/racoon/*.conf
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/racoon
/usr/lib/tmpfiles.d/%{name}.conf
%dir %{_localstatedir}/racoon
%{_mandir}/man5/racoon.conf.5*
%{_mandir}/man8/plainrsa-gen.8*
%{_mandir}/man8/racoon.8*
%{_mandir}/man8/racoonctl.8*
%{_mandir}/man8/setkey.8*

%files -n libipsec
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libipsec.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libipsec.so.0
%attr(755,root,root) %{_libdir}/libracoon.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libracoon.so.0

%files -n libipsec-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libipsec.so
%attr(755,root,root) %{_libdir}/libracoon.so
%{_includedir}/libipsec
%{_includedir}/racoon
%{_mandir}/man3/ipsec_*.3*

%files -n libipsec-static
%defattr(644,root,root,755)
%{_libdir}/libipsec.a
%{_libdir}/libracoon.a
%changelog
* Mon Sep 24 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ipsec-tools.git;a=log;h=master

* Mon Sep 24 2018 Adam Gołębiowski <adamg@pld-linux.org> 0a860f0
- openssl-1.1 support (from debian)
- release 5

* Sat Sep 15 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 8372193
- release 4 (by relup.sh)

* Fri Sep 29 2017 Tomasz Pala <gotar@pld-linux.org> 99491f6
- fixed psk.txt file permissions (were too weak for daemon), removed las

* Tue Oct 18 2016 Jan Rękorajski <baggins@pld-linux.org> 0223e4a
- rebuild with readline 7.0
- release 2 (by relup.sh)

* Sun Aug 09 2015 Jan Rękorajski <baggins@pld-linux.org> 34866a8
- remove sysctl.h includes, not needed and harmful on x32

* Sun Aug 09 2015 Jan Rękorajski <baggins@pld-linux.org> de55c9a
- rel 1

* Sat Jul 04 2015 Jakub Bogusz <qboosh@pld-linux.org> 6fc3350
- added link patch (link libracoon agains libipsec)

* Fri May 29 2015 Mateusz Korniak <matkor@pld-linux.org> 8a61d20
- Up to 0.8.2.  Not tested.

* Sat Feb 16 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 1add899
- fix file duplicates

* Tue Feb 21 2012 Jacek Konieczny <jajcus@pld-linux.org> 7a4818d
- 'without ldap' bcond added

* Tue Jan 31 2012 Jan Rękorajski <baggins@pld-linux.org> 502b523
- release 3

* Tue Jan 31 2012 Jan Rękorajski <baggins@pld-linux.org> e1d30b4
- added tmpfiles config for systemd

* Mon Jan 30 2012 Jan Rękorajski <baggins@pld-linux.org> a51f86a
- add systemd tmpfiles config

* Wed Aug 03 2011 Jan Rękorajski <baggins@pld-linux.org> 2fef37e
- release 2

* Sat Mar 26 2011 Jakub Bogusz <qboosh@pld-linux.org> b6ae0ea
- updated to 0.8.0
- removed obsolete install patch
- fixed libipsec* descriptions

* Sun Feb 20 2011 Jakub Bogusz <qboosh@pld-linux.org> 4c62dcb
- unified sf URL

* Sat Nov 13 2010 pawelz <pawelz@pld-linux.org> 2748530
- release 8

* Mon Oct 04 2010 Jan Rękorajski <baggins@pld-linux.org> 9d6537a
- rel 7
- another library with deps on symbols from program that uses it

* Mon Oct 04 2010 Jan Rękorajski <baggins@pld-linux.org> 83c9144
- rel 6

* Sun Apr 11 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> bcafc66
- release 5

